<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die();

include_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/pdf.php');
 
 
/**
 * DocumentPDF class, provides an easy interface to parse and display a pdf document
 *
 * @package             Joomla.Framework
 * @subpackage  Document
 * @since               1.5
 */
class TViewPdf extends FOFViewHtml
{
        protected $engine = null;
 
        protected $name = 'joomla';
 
        /**
         * Class constructore
         * @param       array   $options Associative array of options
         */
 
        function __construct($config = array())
        {
                parent::__construct($config);
 
                //set mime type
                $this->_mime = 'application/pdf';
 
                //set document type
                $this->_type = 'pdf';
        }
 
      
 
        /**
         * Sets the document name
         * @param   string   $name      Document name
         * @return  void
         */
 
        public function setName($name = 'joomla')
        {
                $this->name = $name;
        }
 
        /**
         * Returns the document name
         * @return      string
         */
 
        public function getName()
        {
                return $this->name;
        }
 
        function  display($tpl = null) {
        
	        // Get the task set in the model
                $model = $this->getModel();
                $task = $model->getState('task','browse');

                // Call the relevant method
                $method_name = 'on'.ucfirst($task);
                if(method_exists($this, $method_name)) {
                        $result = $this->$method_name($tpl);
                } else {
                        $result = $this->onDisplay();
                }
                
                $document = JFactory::getDocument();
        	//$document->setMimeEncoding('application/json');
        
        	/*JError::setErrorHandling(E_ALL,'ignore');
        	$data = $this->loadTemplate($tpl);
        	JError::setErrorHandling(E_WARNING,'callback');*/
        	list($isCli, $isAdmin) = FOFDispatcher::isCliAdmin();
        	
        	$basePath = $isAdmin ? 'admin:' : 'site:';
        	$basePath .= $this->config['option'].'/';
        	$basePath .= $this->config['view'].'/';
        	$path = $basePath.$this->getLayout();
        	
        	if($tpl){
        		$path .= '_'.$tpl;
        	}
        	$data = $this->loadAnyTemplate($path);
        
        	if($data instanceof JException) {
        		echo $data->getMessage();
        		return false;
        	} else {
                        InvoicingHelperPDF::createPDF($data,$this->getName(),true);
                        return false;
        	}
        }
}