<?php
/**
 * @package Invoicing
 * @copyright Copyright (c)203 Juloa.com
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

class InvoicingModelCoupons extends FOFModel
{
    public function qn($name) {
        $db = $this->getDbo();        
       if(version_compare(JVERSION, '3.0', 'ge')) {
			return $db->qn($name);
		} elseif(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->quoteName($name);
		}else {
            return $db->nameQuote($name);
		}           
    }
    
    public function q($name) {
        $db = $this->getDbo();        
        if(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->q($name);
		}else {
            return $db->Quote($name);
		}           
    }
    
	public function buildQuery($overrideLimits = false) {
        
		$db = $this->getDbo();
		
		$query = FOFQueryAbstract::getNew($db)
			->select('*')
			->from($this->qn('#__invoicing_coupons'));
		
		$enabled = $this->getState('enabled','','cmd');
		
		if($enabled !== '') 
			$enabled = (int)$enabled;
			
		
		if(is_numeric($enabled)) {
			$query->where($this->qn('enabled').' = '.(int)$enabled);
		}
		
		$coupon = $this->getState('code','','cmd');
		if(!empty($coupon)) {
			$query->where($this->qn('code').' LIKE '.$this->q($coupon));
		}
		
		$search = $this->getState('search',null);
		if($search)
		{
			$search = '%'.$search.'%';
			$query->where(
				'('.
				'('.$this->qn('title').' LIKE '.$this->q($search).') OR'.
				'('.$this->qn('code').' LIKE '.$this->q($search).')'.
				')'
			);
		}
		
		$order = $this->getState('filter_order', 'invoicing_coupon_id', 'cmd');
		if(!in_array($order, array_keys($this->getTable()->getData()))) $order = 'invoicing_coupon_id';
		$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
		$query->order($order.' '.$dir);

		return $query;
	}
	
	public function onAfterGetItem(&$record) {
		if ($record->apply_on != "")
			$record->apply_on = explode(",",$record->apply_on);
		else
			$record->apply_on = array ("");
		if (in_array("0",$record->apply_on)) {
			$record->apply_on = array("0");
		}
	}
	
	public function onBeforeSave(&$data,&$table) {
		if(isset($data['apply_on'])) {
            $data['apply_on'] = implode(",",$data['apply_on']);
        } else {
            $data['apply_on'] = '0';
        }
		return true;
	}
	
	public function getCoupon($code) {
        $db = JFactory::getDbo();
        
        $query = "SELECT * FROM #__invoicing_coupons WHERE code = '".$code."'";
        
        $db->setQuery($query);
        
        $result = $db->loadObject();
        
        return $result;
    }
	
	
}
