<?php
/**
 * @package Invoicing
 * @copyright Copyright (c)203 Juloa.com
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

include_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/cparams.php');

class InvoicingModelUsers extends FOFModel
{
    public function qn($name) {
        $db = $this->getDbo();        
       if(version_compare(JVERSION, '3.0', 'ge')) {
			return $db->qn($name);
		} elseif(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->quoteName($name);
		}else {
            return $db->nameQuote($name);
		}           
    }
    
    public function q($name) {
        $db = $this->getDbo();        
        if(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->q($name);
		}else {
            return $db->Quote($name);
		}           
    }
    
	public function buildQuery($overrideLimits = false) {
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1 && file_exists(JPATH_ADMINISTRATOR.'/components/com_comprofiler') ) {
			$db =JFactory::getDBO();
			$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
			if ($cb_name == "name") {
				$cbname = "u.".$cb_name;
				$cb_name = "u.".$cb_name." as cb_businessname";
			} else {
				$cbname = "c.".$cb_name;
				$cb_name = "c.".$cb_name." as cb_businessname";
			}
			$select = array();
			
			$cb_city = InvoicingHelperCparams::getParam('cb_city','');
			if ($cb_city != "") {
				$select[]  = "c.".$cb_city." as cb_city";
			}
				
			$cb_address = InvoicingHelperCparams::getParam('cb_address','');
			if ($cb_address != "") {
				$select[]  = "c.".$cb_address." as cb_address";
			}
				
			$cb_address2 = InvoicingHelperCparams::getParam('cb_address2','');
			if ($cb_address2 != "") {
				$select[]  = "c.".$cb_address2." as cb_address2";
			}
			
			$cb_country = InvoicingHelperCparams::getParam('cb_country','');
			if ($cb_country != "") {
				$select[]  = "c.".$cb_country." as cb_country";
			}
			
			$cb_zip = InvoicingHelperCparams::getParam('cb_zip','');
			if ($cb_zip != "") {
				$select[]  = "c.".$cb_zip." as cb_zip";
			}
			
			$cb_firstname = InvoicingHelperCparams::getParam('cb_firstname','');
			if ($cb_firstname != "") {
				$select[]  = "c.".$cb_firstname." as cb_city";
			}
			
			$cb_lastname = InvoicingHelperCparams::getParam('cb_lastname','');
			if ($cb_lastname != "") {
				$select[]  = "c.".$cb_lastname." as cb_lastname";
			}
			
			$cb_mobile = InvoicingHelperCparams::getParam('cb_mobile','');
			if ($cb_mobile != "") {
				$select[]  = "c.".$cb_mobile." as cb_mobile";
			}
			
			$cb_landline = InvoicingHelperCparams::getParam('cb_landline','');
			if ($cb_landline != "") {
				$select[]  = "c.".$cb_landline." as cb_landline";
			}
			
			$cb_notes = InvoicingHelperCparams::getParam('cb_notes','');
			if ($cb_notes != "") {
				$select[]  = "c.".$cb_landline." as cb_notes";
			}
			
			$sqlselect = implode(",",$select);
			if ($sqlselect != "") {
				$sqlselect = ",".$sqlselect;
			}
			
			$query = FOFQueryAbstract::getNew($db);
			$query->select("i.*,u.email,u.username,$cb_name".$sqlselect)
			      ->from("#__invoicing_users as i")
			      ->join("LEFT","#__comprofiler as c ON c.user_id = i.user_id")
			      ->join("LEFT","#__users as u ON i.user_id = u.id");
			$search = $this->getState('search',null);
			if($search)
			{
				$search = '%'.$search.'%';
				$sqlwhere = '(('.$this->qn('i.invoicing_user_id').' LIKE '.$this->q($search).') OR'.
						'('.$this->qn($cbname).' LIKE '.$this->q($search).')';
				if ($cb_lastname != "") {
					$sqlwhere.= ' OR ('.$this->qn("c.".$cb_lastname).' LIKE '.$this->q($search).')';
				}
				if ($cb_firstname != "") {
					$sqlwhere.= ' OR ('.$this->qn("c.".$cb_firstname).' LIKE '.$this->q($search).')';
				}
				$sqlwhere.= ")";
				$query->where($sqlwhere);
			}
			$order = $this->getState('filter_order', 'cb_businessname', 'cmd');
			if ($order == 'businessname') 
				$order = "cb_businessname";
			if ($order == 'id')
				$order = 'u.id';
			$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
			$query->order("$order $dir");
			//echo (string) $query;
			//var_dump($query);
		} else {
			$db = $this->getDbo();
		
			$query = FOFQueryAbstract::getNew($db)
				->select('i.*,u.email,u.username,u.id')
				->from($this->qn('#__invoicing_users')." as i")
				->leftjoin($this->qn('#__users')." AS u on i.user_id = u.id");	
			
			$search = $this->getState('search',null);
			if($search)
			{
				$search = '%'.$search.'%';
				$query->where(
					'('.
					'('.$this->qn('invoicing_user_id').' LIKE '.$this->q($search).') OR'.
					'('.$this->qn('i.businessname').' LIKE '.$this->q($search).') OR '.
					'('.$this->qn('i.firstname').' LIKE '.$this->q($search).') OR '.
					'('.$this->qn('i.lastname').' LIKE '.$this->q($search).')'.
					')'
				);
			}
			
			$city = $this->getState('city',null);
			if($city)
			{
				$city = '%'.$city.'%';
				$query->where($this->qn('city').' LIKE '.$this->q($city));
			}
			
			$zip = $this->getState('zip',null);
			if($zip)
			{
				$zip = '%'.$zip.'%';
				$query->where($this->qn('zip').' LIKE '.$this->q($zip));
			}
			
			$country = $this->getState('country',null);
			if($country)
			{
				$country = '%'.$country.'%';
				$query->where($this->qn('country').' LIKE '.$this->q($country));
			}
			
			$order = $this->getState('filter_order', 'businessname', 'cmd');
			if(!in_array($order, array_keys($this->getTable()->getData()))) $order = 'businessname';
			$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
			$query->order($order.' '.$dir);
		}
		return $query;
	}

	public function onProcessList(&$list) {
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1 && file_exists(JPATH_ADMINISTRATOR.'/components/com_comprofiler')) {
			foreach($list as $key => $item) {
				if (($item->user_id != "0")&&($item->user_id != null)) {
					$list[$key]->businessname = @$list[$key]->cb_businessname;
					$list[$key]->city = @$list[$key]->cb_city;
					$list[$key]->address1 = @$list[$key]->cb_address;
					$list[$key]->address2 = @$list[$key]->cb_address2;
					$list[$key]->zip = @$list[$key]->cb_zip;
					$list[$key]->country = @$list[$key]->cb_country;
					$list[$key]->firstname = @$list[$key]->cb_firstname;
					$list[$key]->lastname = @$list[$key]->cb_lastname;
					$list[$key]->mobile = @$list[$key]->cb_mobile;
					$list[$key]->landline = @$list[$key]->cb_landline;
					$list[$key]->notes = @$list[$key]->cb_notes;
				}
			}
		}
	}
	
	public function getUser($userid) {
		$sql =" SELECT i.*,u.name,u.username, u.email "
		     ." FROM #__invoicing_users as i "
			 ." LEFT JOIN #__users as u ON u.id = i.user_id WHERE u.id=".(int)$userid;
		
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}
	
	public function saveUser($userid,$data) {
		$user = $this->getUser($userid);
		
		if ($user->invoicing_user_id > 0) {
			$this->_db->updateObject('#__invoicing_users',$data,'user_id');
		} else {
			$this->_db->insertObject('#__invoicing_users',$data);
		}
		
		$data = (array)$data;
		
		$user = new stdClass();
		$user->name = $data['businessname'];
		$user->id = $userid; 
		$this->_db->updateObject('#__users',$user,'id');
		
		
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1) {
			$obj = new stdClass();
			$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
			if ($cb_name != "name") {
				$obj->$cb_name = $data['businessname'];
			}
			$cb_city = InvoicingHelperCparams::getParam('cb_city','');
			$cb_address = InvoicingHelperCparams::getParam('cb_address','');
			$cb_address2 = InvoicingHelperCparams::getParam('cb_address2','');
			$cb_zip = InvoicingHelperCparams::getParam('cb_zip','');
			$cb_country = InvoicingHelperCparams::getParam('cb_country','');
				
			if ($cb_city != "")
				$obj->$cb_city = $data['city'];
			if ($cb_address != "")
				$obj->$cb_address = $data['address1'];
			if ($cb_address2 != "")
				$obj->$cb_address2 = $data['address2'];
			if ($cb_zip != "")
				$obj->$cb_zip = $data['zip'];
			if ($cb_country != "")
				$obj->$cb_country = $data['country'];
	
			$obj->user_id = $data['user_id'];
			$obj->id = $data['user_id'];
			
			$obj->confirmed = 1;
			$obj->approved = 1;
			
			$this->_db->setQuery("SELECT id FROM #__comprofiler WHERE id = ".$data['user_id']);
			$result = $this->_db->loadResult();
			if ($result) {
				$obj->id = $result;
				$this->_db->updateObject('#__comprofiler', $obj,'id');
			}
			else
				$this->_db->insertObject('#__comprofiler', $obj);
		}	
	}
	
	public function &getItem($id = null)
	{
		$db =JFactory::getDBO();
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if(!is_null($id)) {
			$this->record = null;
			$this->setId($id);
		}
		
		if ($cb == 1) {	
			if(empty($this->record)) {
				
				$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
				if ($cb_name == "name")
					$cb_name = "u.".$cb_name." as cb_businessname";
				else
					$cb_name = "c.".$cb_name." as cb_businessname";
				
				$select = array();
					
				$cb_city = InvoicingHelperCparams::getParam('cb_city','');
				if ($cb_city != "") {
					$select[]  = "c.".$cb_city." as cb_city";
				}
				
				$cb_address = InvoicingHelperCparams::getParam('cb_address','');
				if ($cb_address != "") {
					$select[]  = "c.".$cb_address." as cb_address";
				}
				
				$cb_address2 = InvoicingHelperCparams::getParam('cb_address2','');
				if ($cb_address2 != "") {
					$select[]  = "c.".$cb_address2." as cb_address2";
				}
					
				$cb_country = InvoicingHelperCparams::getParam('cb_country','');
				if ($cb_country != "") {
					$select[]  = "c.".$cb_country." as cb_country";
				}
					
				$cb_zip = InvoicingHelperCparams::getParam('cb_zip','');
				if ($cb_zip != "") {
					$select[]  = "c.".$cb_zip." as cb_zip";
				}
					
				$cb_firstname = InvoicingHelperCparams::getParam('cb_firstname','');
				if ($cb_firstname != "") {
					$select[]  = "c.".$cb_firstname." as cb_city";
				}
					
				$cb_lastname = InvoicingHelperCparams::getParam('cb_lastname','');
				if ($cb_lastname != "") {
					$select[]  = "c.".$cb_lastname." as cb_lastname";
				}
					
				$cb_mobile = InvoicingHelperCparams::getParam('cb_mobile','');
				if ($cb_mobile != "") {
					$select[]  = "c.".$cb_mobile." as cb_mobile";
				}
					
				$cb_landline = InvoicingHelperCparams::getParam('cb_landline','');
				if ($cb_landline != "") {
					$select[]  = "c.".$cb_landline." as cb_landline";
				}
					
				$cb_notes = InvoicingHelperCparams::getParam('cb_notes','');
				if ($cb_notes != "") {
					$select[]  = "c.".$cb_notes." as cb_notes";
				}
					
				$sqlselect = implode(",",$select);
				if ($sqlselect != "") {
					$sqlselect = ",".$sqlselect;
				}
				
		
				$query = " SELECT i.*,$cb_name,u.username, u.email".$sqlselect
				        ." FROM #__invoicing_users as i "
				        ." LEFT JOIN #__comprofiler as c ON c.user_id = i.user_id "
				        ." LEFT JOIN #__users as u ON u.id = i.user_id WHERE i.invoicing_user_id=".(int)$this->getId();

				$db->setQuery($query);
				$values = $db->loadObject();
				$this->record = @FOFTable::getAnInstance('Users', 'InvoicingTable');//var_dump($this->record);
                $this->record->invoicing_user_id = null;
                $this->record->businessname = null;
                $this->record->username = null;
                $this->record->email = null;
                $this->record->city = null;
                $this->record->address1 = null;
                $this->record->address2 = null; 
                $this->record->zip = null;
                $this->record->firstname = null;
                $this->record->lastname = null;
                $this->record->mobile = null;
                $this->record->landline = null;
                $this->record->notes = null;
                $this->record->country = null;
                
				if ($values != null) {
					foreach($values as $key => $val) {
						$this->record->$key = $val;
					}
				}
				if ((isset($this->record->user_id)) && ($this->record->user_id != 0)) {
					$this->record->businessname = @$this->record->cb_businessname;
					$this->record->city = @$this->record->cb_city;
					$this->record->address1 = @$this->record->cb_address;
					$this->record->address2 = @$this->record->cb_address2;
					$this->record->zip = @$this->record->cb_zip;
					$this->record->country = @$this->record->cb_country;
					$this->record->firstname = @$this->record->cb_firstname;
					$this->record->lastname = @$this->record->cb_lastname;
					$this->record->mobile = @$this->record->cb_mobile;
					$this->record->landline = @$this->record->cb_landline;
					$this->record->notes = @$this->record->cb_notes;
				}
				$this->onAfterGetItem($this->record);
			}
			return $this->record;
		} else {
			if ($this->getId() != 0) {
				$query = "SELECT i.*,u.username, u.email FROM #__invoicing_users as i LEFT JOIN #__users as u ON u.id = i.user_id WHERE i.invoicing_user_id=".(int)$this->getId();
				$db->setQuery($query);
				$values = $db->loadObject();
				$this->record = @FOFTable::getAnInstance('Users', 'InvoicingTable');//var_dump($this->record);
                $this->record->invoicing_user_id = null;
                $this->record->businessname = null;
                $this->record->username = null;
                $this->record->email = null;
                $this->record->city = null;
                $this->record->address1 = null;
                $this->record->address2 = null; 
                $this->record->zip = null;
                $this->record->country = null;
                $this->record->firstname = null;
                $this->record->lastname = null;
                $this->record->mobile = null;
                $this->record->landline = null;
                $this->record->notes = null;
                
				if ($values != null) {
					foreach($values as $key => $val) {
						$this->record->$key = $val;
					}
				}
				$this->onAfterGetItem($this->record);
				return $this->record;
			} else {
				return parent::getItem($id);	
			}
		}		
	}

	public function createUser($user_id) {
		$db =JFactory::getDBO();
        $sql = "SELECT * FROM #__users WHERE id = ".(int)$user_id;
		$db->setQuery($sql);
        $user = $db->loadObject();
		$obj = new stdClass();
		$obj->user_id = $user_id;
        $obj->businessname = $user->username;
		$db->insertObject('#__invoicing_users', $obj);
	}

	public function getInvoicingUser($user_id) {
		$db =JFactory::getDBO();
		$sql = "SELECT invoicing_user_id FROM #__invoicing_users WHERE user_id = ".(int)$user_id;
		$db->setQuery($sql);
		$invoicing_user_id = $db->loadResult();
		return $invoicing_user_id;
	}
	
	public function save($data)
	{
		$db =JFactory::getDBO();
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1) {
			$data = JRequest::get('post');
			$table = null;
			if(!$this->onBeforeSave($data, $table)) {
				return false;
			}
			if ($data['user_id'] != null) {
				$obj = new stdClass();
				$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
				if ($cb_name != "name") {
					$obj->$cb_name = $data['businessname'];
				}
				$cb_city = InvoicingHelperCparams::getParam('cb_city','');
				$cb_address = InvoicingHelperCparams::getParam('cb_address','');
				$cb_address2 = InvoicingHelperCparams::getParam('cb_address2','');
				$cb_zip = InvoicingHelperCparams::getParam('cb_zip','');
				$cb_country = InvoicingHelperCparams::getParam('cb_country','');
				$cb_firstname = InvoicingHelperCparams::getParam('cb_firstname','');
				$cb_lastname = InvoicingHelperCparams::getParam('cb_lastname','');
				$cb_mobile = InvoicingHelperCparams::getParam('cb_mobile','');
				$cb_landline = InvoicingHelperCparams::getParam('cb_landline','');
				$cb_notes = InvoicingHelperCparams::getParam('cb_notes','');
			
				if ($cb_city != "")
					$obj->$cb_city = $data['city'];
				if ($cb_address != "")
					$obj->$cb_address = $data['address1'];
				if ($cb_address2 != "")
					$obj->$cb_address2 = $data['address2'];
				if ($cb_zip != "")
					$obj->$cb_zip = $data['zip'];
				if ($cb_country != "")
					$obj->$cb_country = $data['country'];
				if ($cb_landline != "")
					$obj->$cb_landline = $data['landline'];
				if ($cb_mobile != "")
					$obj->$cb_mobile = $data['mobile'];
				if ($cb_firstname != "")
					$obj->$cb_firstname = $data['firstname'];
				if ($cb_lastname != "")
					$obj->$cb_lastname = $data['lastname'];
				if ($cb_notes != "")
					$obj->$cb_notes = $data['notes'];
				
				$obj->user_id = $data['user_id'];
				$obj->id = $data['user_id'];
				$db->updateObject('#__comprofiler',$obj,'id');	
			}	
		}
		parent::save($data);
		return true;
	}
	
	public function onBeforeSave(&$data,&$table) {
		$db =JFactory::getDBO();
		if ((@$data['user_id'] == null)&&(@$data['create_user'] != null)) {	
			$params = JComponentHelper::getParams('com_users');
			// Save User using Joomla code
			if (version_compare(JVERSION,'1.6.0','<')) {
				$authorize	= JFactory::getACL();
			
				$user = clone(JFactory::getUser());
					
				// Initialize new usertype setting
				$newUsertype = $params->get( 'new_usertype' );
				if (!$newUsertype) {
					$newUsertype = 'Registered';
				}
					
				// Bind the post array to the user object
				$post = JRequest::get('post');
				$post['password2'] = $post['password'];
				if (!$user->bind($post, 'usertype' )) {
					JError::raiseError( 500, $user->getError());
				}
			
				// Set some initial user values
				$user->set('id', 0);
				$user->set('usertype', $newUsertype);
				$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));
			
				$date = JFactory::getDate();
				$user->set('registerDate', $date->toMySQL());
			
				// If user activation is turned on, we need to set the activation information
				$useractivation = $params->get( 'useractivation' );
				if ($useractivation == '1')
				{
					jimport('joomla.user.helper');
					$user->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
					//$user->set('block', '1');
				}
			
				// If there was an error with registration, set the message and display form
				if ( !$user->save() )
				{
					JError::raiseWarning('', JText::_( $user->getError()));
					return false;
				}
			} else {
				// Initialise the table with JUser.
				$user = new JUser;
			
				// Prepare the data for the user object.
				$useractivation = $params->get('useractivation');
			
				// Check if the user needs to activate their account.
				if (($useractivation == 1) || ($useractivation == 2)) {
					jimport('joomla.user.helper');
					if (version_compare(JVERSION,'3.0.0','>=')) {
						$data['activation'] = JApplication::getHash(JUserHelper::genRandomPassword());
					} else {
						$data['activation'] = JUtility::getHash(JUserHelper::genRandomPassword());
					}
					//$data['block'] = 1;
				}
					
				// Get the groups the user should be added to after registration.
				$data['groups'] = array();
				// Get the default new user group, Registered if not specified.
				$system	= $params->get('new_usertype', 2);
				$data['groups'][] = $system;
				
				$data['name'] = $data['businessname'];
			
				//var_dump($data);exit();
				// Bind the data.
				if (!$user->bind($data)) {
					$this->setError(JText::sprintf('COM_USERS_REGISTRATION_BIND_FAILED', $user->getError()));
					return false;
				}
			
				// Load the users plugin group.
				JPluginHelper::importPlugin('user');
			
				// Store the data.
				if (!$user->save()) {
					$this->setError(JText::sprintf('COM_USERS_REGISTRATION_SAVE_FAILED', $user->getError()));
					return false;
				}
			}
			$query = "SELECT MAX(id) FROM #__users";
			$db->setQuery($query);
			$userid = $db->loadResult();
			$data['user_id'] = $userid;

			/*$obj = new stdClass();
			$obj->invoicing_user_id = $userid;
			$obj->user_id = $userid;
			$db->insertObject('#__invoicing_users', $obj);*/
			
			$cb = InvoicingHelperCparams::getParam('cb',0);
			if ($cb == 1)
			{	
				$obj = new stdClass();
				$obj->id = $userid;
				$obj->user_id = $userid;
				$db->insertObject('#__comprofiler', $obj);
			}
		} else if (@$data['user_id'] != null) {
			$obj = new stdClass();
			$obj->name = JRequest::getVar('businessname','');
			$obj->email = JRequest::getVar('email','');
			if (($obj->name != "")&&($obj->email != "")) {
				$obj->id = JRequest::getVar('user_id','');
				
				if (JRequest::getVar('password','')) {
					jimport('joomla.user.helper');
					$salt = JUserHelper::genRandomPassword(32);
					$crypt = JUserHelper::getCryptedPassword(JRequest::getVar('password',''), $salt);
					$obj->password = $crypt.':'.$salt;
				}
				$db->updateObject('#__users', $obj,'id');
			}
		}
		return true; 
	}
}
