<?php
/**
 * @package Invoicing
 * @copyright Copyright (c)203 Juloa.com
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

jimport( 'joomla.filesystem.file' );

class InvoicingModelVendors extends FOFModel
{
    public function qn($name) {
        $db = $this->getDbo();        
       if(version_compare(JVERSION, '3.0', 'ge')) {
			return $db->qn($name);
		} elseif(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->quoteName($name);
		}else {
            return $db->nameQuote($name);
		}           
    }
    
    public function q($name) {
        $db = $this->getDbo();        
        if(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->q($name);
		}else {
            return $db->Quote($name);
		}           
    }
    
	public function buildQuery($overrideLimits = false) {
		$db = $this->getDbo();
		
		$query = FOFQueryAbstract::getNew($db)
			->select('*')
			->from($this->qn('#__invoicing_vendors'));
		
		$search = $this->getState('search',null);
		if($search)
		{
			$search = '%'.$search.'%';
			$query->where(
				'('.
				'('.$this->qn('invoicing_vendor_id').' LIKE '.$this->q($search).') OR'.
				'('.$this->qn('contact_name').' LIKE '.$this->q($search).') OR'.
				'('.$this->qn('company_name').' LIKE '.$this->q($search).')'.
				')'
			);
		}
		
		$order = $this->getState('filter_order', 'invoicing_vendor_id', 'cmd');
		if(!in_array($order, array_keys($this->getTable()->getData()))) $order = 'invoicing_vendor_id';
		$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
		$query->order($order.' '.$dir);

		return $query;
	}
	
	protected function onBeforeSave(&$data, &$table) {
	
		$formats = array("png","jpg","gif");

 		$files = JRequest::get( 'files' );
		
		if (isset($files['filename']['name']) and !$files['filename']['error']) {
		
			$filename = $files['filename']['name'];
		
			$uniqid = uniqid();
			$extension = JFile::getExt($filename);
			$filename = "logo-".$data["invoicing_vendor_id"].".".$extension;
			
			if ($table->filename != "") {
				jFile::delete(JPATH_ROOT."/media/com_invoicing/images/vendor/".$table->filename);
			}

			 if (strpos($extension,"php") !== false) {
				 $extension = 'txt';
			 }
			 
			 else {
					if ( in_array($extension,$formats)) {
						$extension = strtolower($extension);
						JFile::upload($files['filename']['tmp_name'],JPATH_ROOT."/media/com_invoicing/images/vendor/".$filename);

						$table->filename = $filename;
					}	
			}
		}
		else {
					if (JRequest::getInt("delete_".$files['filename']['name']) == 1) {
						if (file_exists(JPATH_ROOT."/media/com_invoicing/images/vendor/".$files['filename']['name'])) {
							JFile::delete(JPATH_ROOT."/media/com_invoicing/images/vendor/".$files['filename']['name']);
						}
						$table->filename = "";
					}
				}
		
		return (parent::onBeforeSave($data,$table));
	}
	
	
}
