<?php
/**
 *  @package Invoicing
 *  @copyright Copyright (c)203 Juloa.com
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

JHtml::_('behavior.tooltip');
JHtml::_('behavior.modal');

if(version_compare(JVERSION, '3.0', 'ge')) {
	JHTML::_('behavior.framework');
} else {
	JHTML::_('behavior.mootools');
}

JHtml::_('formbehavior.chosen', 'select', null, array('disable_search_threshold'=>1));

$this->loadHelper('select');
$this->loadHelper('cparams');
$this->loadHelper('format');
?>
<div class="row-fluid">
<div class="span12">

<form action="index.php" method="post" name="adminForm" id="adminForm">
<input type="hidden" name="option" value="com_invoicing" />
<input type="hidden" name="view" value="invoices" />
<input type="hidden" id="task" name="task" value="browse" />
<input type="hidden" name="hidemainmenu" id="hidemainmenu" value="0" />
<input type="hidden" name="boxchecked" id="boxchecked" value="0" />
<input type="hidden" name="filter_order" id="filter_order" value="<?php echo $this->lists->order ?>" />
<input type="hidden" name="filter_order_Dir" id="filter_order_Dir" value="<?php echo $this->lists->order_Dir ?>" />
<?php echo JHTML::_( 'form.token' ); ?>

<div align="right">
<a href="<?php echo JRoute::_('index.php?option=com_invoicing&view=invoices&format=csv')?>">
	<?php echo JText::_('INVOICING_DOWNLOAD_CSV') ?>
 </a>
</div>

<input type="text" name="search" id="search"
	value="<?php echo $this->escape($this->getModel()->getState('search',''));?>"
	class="input-medium" onchange="document.adminForm.submit();"
	placeholder="<?php echo JText::_('COM_INVOICING_COMMON_SEARCH')?>"
	/>
	
<nobr>
	
<button class="btn btn-mini" onclick="this.form.submit();">
	<?php echo JText::_('JSEARCH_FILTER'); ?>
</button>
<button class="btn btn-mini" onclick="document.adminForm.search.value='';this.form.submit();">
	<?php echo JText::_('JSEARCH_RESET'); ?>
</button>

</nobr>

<div class="filter-select fltrt">
<?php echo JHTML::_('calendar',$this->escape($this->getModel()->getState('dateFilterFrom','')), "dateFilterFrom", "dateFilterFrom", "%Y-%m-%d");?>
	<?php echo JHTML::_('calendar',$this->escape($this->getModel()->getState('dateFilterTo','')), "dateFilterTo", "dateFilterTo", "%Y-%m-%d");?>
	<button class="btn btn-mini" onclick="document.adminForm.submit();"><?php echo JText::_('INVOICING_FILTER'); ?></button>
<?php echo InvoicingHelperSelect::coupons('coupon_id',$this->getModel()->getState('coupon_id',''), array('include_all'=>true,'onchange'=>'this.form.submit();', 'class'=>'input-medium')) ?>
<?php echo InvoicingHelperSelect::processors($this->getModel()->getState('processor',''),'processor', array('onchange'=>'this.form.submit();', 'class'=>'input-medium')) ?>
<?php echo InvoicingHelperSelect::invoicestatus($this->getModel()->getState('status',''), 'status', array('include_all'=>true,'onchange'=>'this.form.submit();', 'class'=>'input-medium')) ?>
<?php echo InvoicingHelperSelect::vendors('vendor_id',$this->getModel()->getState('vendor_id',''), array('onchange'=>'this.form.submit();', 'class'=>'input-medium')) ?>
<?php echo InvoicingHelperSelect::users('user_id',$this->getModel()->getState('user_id',''), array('onchange'=>'this.form.submit();', 'class'=>'input-medium')) ?>
</div>

<table class="adminlist table table-striped" id="itemsList">
	<thead>
		<tr>
			<th>
				<?php echo JHTML::_('grid.sort', 'Num', 'invoicing_invoice_id', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th></th>
			<th>
				<?php echo JHTML::_('grid.sort', 'COM_INVOICING_TITLE_INVOICES', 'invoice_number', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th>
				<?php echo JHTML::_('grid.sort', 'COM_INVOICING_TITLE_ORDERS', 'order_number', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th>
				<?php echo JText::_('INVOICING_COMMON_INVOICE_SUBJECT');?>
			</th>	
			<th>
				<?php echo JHTML::_('grid.sort', 'COM_INVOICING_TITLE_USERS', 'user_id', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th>
				<?php echo JHTML::_('grid.sort', 'COM_INVOICING_TITLE_VENDORS', 'vendor_id', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th>
				<?php echo JText::_('INVOICING_COMMON_COUPON');?>
			</th>	
			<th>
				<?php echo JText::_('INVOICING_INVOICE_DISCOUNT_AMOUNT');?>
			</th>	
			<th>
				<?php echo JText::_('INVOICING_INVOICE_NET_AMOUNT');?>
			</th>	
			<th>
				<?php echo JText::_('INVOICING_INVOICE_TAX_AMOUNT');?>
			</th>	
			<th>
				<?php echo JHTML::_('grid.sort', 'INVOICING_INVOICE_GROSS_AMOUNT', 'gross_amount', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>	
			<th width="8%">
				<?php echo JHTML::_('grid.sort', 'INVOICING_COMMON_STATUS', 'status', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th width="8%">
				<?php echo JHTML::_('grid.sort', 'INVOICING_COMMON_INVOICE_PROCESSOR', 'processor', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th width="10%">
				<?php echo JText::_('INVOICING_INVOICE_CREATED_ON');?>
			</th>		
			<th width ="10%">
				<?php echo JText::_('INVOICING_INVOICE_ACTIONS');?>
			</th>	
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="20">
				<?php if($this->pagination->total > 0) echo $this->pagination->getListFooter() ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
		<?php if($count = count($this->items)): ?>
		<?php $i = -1; $m = 0; ?>
		<?php foreach ($this->items as $invoice) : ?>
		<?php
			$i++; $m = 1-$m;
			//$checkedOut = ($invoice->locked_by != 0);
			$checkedOut = false;
			$ordering = $this->lists->order == 'ordering';
		?>
		<tr class="<?php echo  'row'.$m; ?>">
			<td align="center">
				<?php echo $invoice->invoicing_invoice_id; ?>
			</td>
			<td align="center">
				<?php echo JHTML::_('grid.id', $i, $invoice->invoicing_invoice_id, $checkedOut); ?>
			</td>
			<td align="center">
				<a href="index.php?option=com_invoicing&view=invoice&id=<?php echo $invoice->invoicing_invoice_id; ?>">
				<strong><?php echo $this->escape(InvoicingHelperFormat::formatInvoiceNumber($invoice)); ?></strong>
				</a>
			</td>
			<td align="center">
				<a href="index.php?option=com_invoicing&view=invoice&id=<?php echo $invoice->invoicing_invoice_id; ?>">
				<strong><?php echo $this->escape(InvoicingHelperFormat::formatOrderNumber($invoice)); ?></strong>
				</a>
			</td>
			<td>
				<a href="index.php?option=com_invoicing&view=invoice&id=<?php echo $invoice->invoicing_invoice_id; ?>">
				<strong><?php echo $this->escape($invoice->subject); ?></strong>
				</a>
			</td>
			<td align="center">
				<a href="index.php?option=com_invoicing&view=user&id=<?php echo $invoice->user_id; ?>">
					<?php echo InvoicingHelperFormat::formatUser($invoice->user_id,"businessname") ?>
				</a>
			</td>
			<td align="center">
				<a href="index.php?option=com_invoicing&view=vendor&id=<?php echo $invoice->vendor_id; ?>">
					<?php echo InvoicingHelperFormat::formatVendor($invoice->vendor_id,"contact_name") ?>
				</a>
			</td>
			<td align="center">
				<?php echo InvoicingHelperFormat::formatCoupon($invoice->coupon_id); ?>
			</td>
			<td align="center">
				<?php echo InvoicingHelperFormat::formatPrice($invoice->net_discount_amount,$invoice->currency_id); ?>
			</td>
			<td align="center">
				<?php echo InvoicingHelperFormat::formatPrice($invoice->net_amount,$invoice->currency_id); ?>
			</td>			
			<td align="center">
				<?php echo InvoicingHelperFormat::formatPrice($invoice->tax_amount,$invoice->currency_id); ?>
			</td>
			<td align="center">
					<strong><?php echo  InvoicingHelperFormat::formatPrice($invoice->gross_amount,$invoice->currency_id) ?></strong>
			</td>
			<td align="center"><?php echo InvoicingHelperFormat::formatInvoiceStatus($invoice->status)?></td>
			<td align="center"><?php echo InvoicingHelperFormat::formatProcessor($invoice->processor)?></td>
			<td align="center"><?php 
				echo InvoicingHelperFormat::formattedDate($invoice->created_on);
			?></td>
			<td align="center">
				<div id="pic_actions">
				
				<a id="see_pic_actions" class="modal" rel="{handler: 'iframe', size: {x: 900, y: 600}}" href="index.php?option=com_invoicing&view=invoice&task=read&id=<?php echo $this->escape($invoice->invoicing_invoice_id) ?>&tmpl=component&print=1"></a>
				<a id="pdf_pic_actions" href="index.php?option=com_invoicing&view=invoice&id=<?php echo $this->escape($invoice->invoicing_invoice_id) ?>&task=read&tmpl=component&format=pdf"></a>
				<a id="send_pic_actions" href="index.php?option=com_invoicing&view=invoice&id=<?php echo $this->escape($invoice->invoicing_invoice_id)?>&task=mail"></a>
				<!-- <a id="pdf_pic_actions" href="#"></a>-->
				</div>
			</td>
		</tr>
		<?php endforeach; ?>	
		<?php else: ?>
		<tr>
			<td colspan="20">
				<?php echo  JText::_('COM_INVOICING_COMMON_NORECORDS') ?>
			</td>
		</tr>
		<?php endif; ?>
	</tbody>
</table>

</form>
	
</div>
</div>
