<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

JHtml::_('behavior.tooltip');
if(version_compare(JVERSION, '3.0', 'ge')) {
	JHTML::_('behavior.framework');
} else {
	JHTML::_('behavior.mootools');
}
JHtml::_('behavior.modal');

FOFTemplateUtils::addJS('media://com_invoicing/js/jquery.validate.js');

$this->loadHelper('cparams');
$this->loadHelper('select');
$this->loadHelper('params');
$this->loadHelper('format');

if(version_compare(JVERSION, '1.6', 'ge')) {
    $id = $this->input->get('id');
} else {
    $id = JRequest::getInt('id', 0);
}
?>

<form action="index.php" method="post" name="adminForm" id="adminForm" class="adminForm form formValidation">
<input type="hidden" name="option" value="com_invoicing" />
<input type="hidden" name="view" value="template" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="invoicing_template_id" value="<?php echo $this->item->invoicing_template_id ?>" />
<?php echo JHTML::_( 'form.token' ); ?>

<table cellspacing="0" cellpadding="0" width="100%">
<tr valign="top"><div width="60%">	
				<div id="template_tags" rowspan=4>
						<?php InvoicingHelperFormat::displayTags(); ?>
				</div>
				<div id="template_description"><?php echo JText::_('INVOICING_TEMPLATE_DESCRIPTION'); ?>
				<?php echo JText::_($this->escape($this->item->description)) ?></div>

				<div id="template_htmlcontent"><?php echo JText::_('INVOICING_TEMPLATE_HTMLCONTENT'); ?></div>
				<div id="template_htmlbutton">
					<a id="openhtmlcontent_link" class="modal" rel="{handler: 'iframe', size: {x: 800, y: 500}}" href="index.php?option=com_invoicing&view=template&layout=modal&tmpl=component&type=html&field=htmlcontent&id=<?php echo $id ?>">
					<input size="50" type="button" class="button btn" name="listtemplateshtml" value= "<?php echo JText::_('INVOICING_TEMPLATES_LIST_TEMPLATES_HTML'); ?>" /></a>
				</div>
				<div id="template_htmlcontent_textarea"><textarea id="htmlcontent" name="htmlcontent"><?php echo $this->escape($this->item->htmlcontent) ?> </textarea></div>
				
			<div id="template_usehtmlforpdf">
				<input type="hidden" name="usehtmlforpdf" value=""/> 
				<input size="30" type="checkbox" id="usehtmlforpdf" name="usehtmlforpdf" value='1' <?php if ($this->item->usehtmlforpdf) echo "checked"; ?> />
				<?php echo JText::_('INVOICING_TEMPLATE_USEHTMLFORPDF')?>
			</div>
			<div id="_pdfcontent">
				<div id="template_pdfcontent"><?php echo JText::_('INVOICING_TEMPLATE_PDFCONTENT'); ?></div>
				<div id="template_pdfbutton">
					<a id="openpdfcontent_link" class="modal" rel="{handler: 'iframe', size: {x: 800, y: 500}}" href="index.php?option=com_invoicing&view=template&layout=modal&tmpl=component&type=pdf&field=pdfcontent&id=<?php echo $id ?>">
					<input size="50" type="button" class="button btn" name="listtemplatespdf" value= "<?php echo JText::_('INVOICING_TEMPLATES_LIST_TEMPLATES_PDF'); ?>" /></a>
				</div>
				<div id="template_pdfcontent_textarea"><textarea id="pdfcontent" name="pdfcontent"><?php echo $this->escape($this->item->pdfcontent) ?> </textarea></div>
			</div>
			</div>
	</div></tr>
	</table>
</form>
	
<script type="text/javascript">
window.addEvent("domready", function() {
	$$("button.modal").each(function(el) {
		el.addEvent("click", function(e) {
			try {
				new Event(e).stop();
			} catch(anotherMTUpgradeIssue) {
				try {
					e.stop();
				} catch(WhateverIsWrongWithYouIDontCare) {
					try {
						DOMEvent(e).stop();
					} catch(NoBleepinWay) {
						alert('If you see this message, your copy of Joomla! is FUBAR');
					}
				}
			}
			SqueezeBox.fromElement($('userselect'), {
				parse: 'rel'
			});
		});
	});
});
<?php if(version_compare(JVERSION,'1.6.0','>=')){ ?>
Joomla.submitbutton = function(pressbutton) {
<?php } else { ?>
function submitbutton(pressbutton) {
<?php } ?>
	if (pressbutton == 'cancel') {
		   submitform(pressbutton);	
		   return;
	}
    if(jQ("#adminForm").valid()){
    	submitform(pressbutton);	
    }else{
        return false;
    }
}

jQ("#usehtmlforpdf").click( function(){
   if( jQ(this).is(':checked') ) {
	   jQ('#_pdfcontent').hide();
	} 
	else {
		jQ('#_pdfcontent').show();
	}
});

jQ().ready(function() { 
    // validate signup form on keyup and submit 
     var validator =jQ("#adminForm").validate({ 
         rules: { 
			 content: { 
        	     required: true
			   }
			},
         messages: { 
			 content: { 
        	     required: "<?php echo JText::_('INVOICING_VALIDATION_FIELD_REQUIRED');?>"
			   }
         }         
     });
	 
	if( jQ("#usehtmlforpdf").is(':checked') ) {
	   jQ('#_pdfcontent').hide();
	} 
});
</script>