<?php
/**
 *  @package Invoicing
 *  @copyright Copyright (c)2010-2012 JoomPROD
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

include_once(JPATH_ROOT.'/administrator/components/com_invoicing/controllers/default.php');

class InvoicingControllerPayment extends InvoicingControllerDefault
{
	public function __construct($config = array()) {
		parent::__construct($config);

		$this->csrfProtection = false;

		$this->cacheableTasks = array();

		$this->setThisModelName('InvoicingModelPayment');
	}

	public function execute($task) {
		if (($task != "process")&&($task != 'checkcoupon')&&($task != "validorder")) {
			$task = 'add';
		}

		FOFInput::setVar('task',$task,$this->input);
		parent::execute($task);
	}

	public function process($cachable = false) {
		$paymentmethod = JRequest::getCmd('method','none');
		$result = FOFModel::getTmpInstance('Payment', 'InvoicingModel')->runCallback($paymentmethod);
		echo $result ? 'OK' : 'FAILED';
		JFactory::getApplication()->close();
	}

	/**
	 * I don't want an ACL check
	 *
	 * @return bool
	 */
	public function onBeforeAdd() {
		return true;
	}

	public function checkcoupon()
	{
		$app = JFactory::getApplication();
		$user		= JFactory::getUser();

		$couponcode = JRequest::getVar('couponcode', '');

        if($couponcode == '') {
            $coupon = null;
        }else{
            $coupon = FOFModel::getTmpInstance('Coupons', 'InvoicingModel')
                    ->getCoupon($couponcode);

            if(!isset($coupon->invoicing_coupon_id))
                $coupon = null;
        }
		$id = JRequest::getInt('id', '');
		//echo $user->id;
		$imodel =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel');

		$invoicing_user_id = FOFModel::getTmpInstance('Users', 'InvoicingModel')->getInvoicingUser($user->id);
		$invoice = $imodel->getItem($id);

		if(!JFactory::getUser()->guest) {
			$invoicing_user_id = FOFModel::getTmpInstance('Users', 'InvoicingModel')->getInvoicingUser($user->id);
			if ($invoicing_user_id != $invoice->user_id) {
				exit();
			}
		}


		if(empty($invoice->invoicing_invoice_id))
			$invoice = null;

		if ($invoice == null)
			exit();

		if(JFactory::getUser()->guest) {
			// Security:  If the buyer is not linked to a joomla account, the URL should contains a key to identified the buyer
			if ((int) $invoice->buyer->user_id == 0) {
				$key = $app->getUserStateFromRequest("com_invoicing.invoice.key",			'key',		0,			'string');
				if ($key != InvoicingHelperFormat::key($invoice)) {
					exit();
				}
			} else {
				exit();
			}
		}

		if ($coupon != null) {
			if ($imodel->isCouponUserLimitExceeded($coupon,$invoicing_user_id) == true) {
				$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&layout=payment&id='.$invoice->invoicing_invoice_id.'&couponstatus=error'), JText::_('INVOICING_COUPON_USERHITSLIMIT_EXCEEDED'),"message" );
			}
			else if ($coupon->hitslimit != 0 && $coupon->hitslimit <= $coupon->hits) {
				$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&layout=payment&id='.$invoice->invoicing_invoice_id.'&couponstatus=error'), JText::_('INVOICING_COUPON_LIMIT_EXCEEDED'),"message" );
			}
			else
			{
					$imodel->onAfterGetItem($invoice);
					$couponapplies = $imodel->setCoupon($coupon,$invoice);
					if($couponapplies) {
					$imodel->setCoupon($coupon,$invoice);
						$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&layout=payment&id='.$invoice->invoicing_invoice_id.'&couponstatus=valid') );
					}
					else {
						$imodel->removeCoupon($invoice);
						$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&layout=payment&id='.$id.'&couponstatus=error') );
					}
			}
		} else {
			$imodel->removeCoupon($invoice);
			$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&layout=payment&id='.$id.'&couponstatus=error') );
		}
	}

	/**
	* Set Order -> Paid, => only if invoice net_amount = 0
	*/
	public function validorder() {
		$app = JFactory::getApplication();
		$user		= JFactory::getUser();

		$id = JRequest::getInt('id',0);
		$imodel =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel');

		$invoice = $imodel->getItem($id);
		if(!JFactory::getUser()->guest) {
			$invoicing_user_id = FOFModel::getTmpInstance('Users', 'InvoicingModel')->getInvoicingUser($user->id);
			if ($invoicing_user_id != $invoice->user_id) {
				exit();
			}
		}

		if(empty($invoice->invoicing_invoice_id))
			$invoice = null;
		if ($invoice == null)
			exit();
		if(JFactory::getUser()->guest) {
			// Security:  If the buyer is not linked to a joomla account, the URL should contains a key to identified the buyer
			if ((int) $invoice->buyer->user_id == null) {

				$key = $app->getUserStateFromRequest("com_invoicing.invoice.key",'key',	0,'string');
				if ($key != InvoicingHelperFormat::key($invoice)) {
					exit();
				}
			} else {
				exit();
			}
		}

		if (($invoice->status == "PAID")||($invoice->status == "CANCELLED")) {

			//If not log in, redirect the the invoice instead of "my invoices page"
			if(JFactory::getUser()->guest) {
				$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&id='.$invoice->invoicing_invoice_id),JText::_('INVOICING_ERROR'),"message" );
			}
			else if (file_exists(JPATH_ROOT.'/components/com_comprofiler/'))
				$app->redirect( JRoute::_('index.php?option=com_comprofiler&tab=InvoicingTab'),JText::_('INVOICING_ERROR'),"message" );
			else
				$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoices'),JText::_('INVOICING_ERROR'),"message" );
		}

		if ($invoice->net_amount != 0)
			exit();

		$imodel->save(array('invoicing_invoice_id'=>$id,
							 'processor' => '',
							 'status'=>'PAID'));

		//If not log in, redirect the the invoice instead of "my invoices page"
		if(JFactory::getUser()->guest) {
			$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoice&id='.$invoice->invoicing_invoice_id),JText::_('INVOICING_ORDER_CONFIRMED'),"message" );
		}

		else if (file_exists(JPATH_ROOT.'/components/com_comprofiler/'))
			$app->redirect( JRoute::_('index.php?option=com_comprofiler&tab=InvoicingTab'),JText::_('INVOICING_ORDER_CONFIRMED'),"message" );
		else
			$app->redirect( JRoute::_('index.php?option=com_invoicing&view=invoices'),JText::_('INVOICING_ORDER_CONFIRMED') ,"message");
	}
}
