<?php
/**
 * @package Invoicing
 * @copyright Copyright (c)203 Juloa.com
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

class InvoicingDispatcher extends FOFDispatcher
{
	private $allowedViews = array(
			'message','payment','invoices','invoice','user'
	);
	
	public function __construct($config = array()) {
		parent::__construct($config);
	
		$this->defaultView = 'invoices';
	}
	
	public function onBeforeDispatch() {	
		if ($result = parent::onBeforeDispatch()) {
			include_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/cparams.php');
			
			$document = JFactory::getDocument();
            
            $loadBootstrap = (int)InvoicingHelperCparams::getParam('bootstrap_loading', '1');
            if($loadBootstrap == 1)
                JuloaLib::loadCSS('bootstrap2');
            JuloaLib::loadJquery();
			
			FOFTemplateUtils::addCSS('media://com_invoicing/css/frontend.css');
			
			// Default to the "levels" view
			$view = $this->input->get('view',$this->defaultView);
			if(empty($view) || ($view == 'cpanel') || ($view == 'cpanels')) {
				$view = 'invoices';
			}
            
			// Set the view, if it's allowed
			FOFInput::setVar('view',$view,$this->input);
			if(!in_array($view, $this->allowedViews)) $result = false;
		}
			
		return $result;
	}
}
