<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');
require_once(dirname(__FILE__)."/systempay/vads_api.php");

class plgInvoicingpaymentSystempay extends InvoicingAbstractPaymentPlugin
{
	public function __construct(&$subject, $config = array())
	{
		if(version_compare(JVERSION, '1.6', 'ge')) {
			$defaultimg = JURI::root().'plugins/invoicingpayment/systempay/systempay/systempay.jpg';
		} else {
			$defaultimg = JURI::root().'plugins/invoicingpayment/systempay/systempay.jpg';
		}	
		
		$config = array_merge($config, array(
			'ppName'		=> 'systempay',
			'ppKey'			=> 'PLG_INVOICINGPAYMENT_SYSTEMPAY_TITLE',
			'ppImage'		=> $defaultimg)
				);
		
		parent::__construct($subject, $config);
	}

	function onInvoicingPaymentDisplay($paymentmethod,$data)
	{	
		if($paymentmethod != $this->ppName) return false;
		
		$user = JFactory::getUser();
		
		$item =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel')->getItem($data->invoicing_invoice_id);
		$item->save(array("processor"=>'systempay'));
		
		$this->config = new stdClass();
		$this->config->site = $this->params->get('site','12345678');
		$this->config->test_key = $this->params->get('test_key','1111111111111111');
		$this->config->prod_key = $this->params->get('prod_key','2222222222222222');
		$this->config->devise = $this->params->get('devise',978);
		$this->config->mode = $this->params->get('mode','TEST');
		
		//chargement de la langue
		$lang = JFactory::getLanguage();
		$lang->load("plg_paidsystem_systempay",JPATH_ADMINISTRATOR);
		
		$locale = strtolower(substr($lang->get('tag'), 0, 2));
		//echo $locale;
		$vads_language = in_array($locale, VadsApi::getSupportedLanguages()) ? $locale : 'fr';
				
		$url_success = JURI::base().'index.php?option=com_invoicing&view=message&layout=complete';
		$url_cancel = JURI::base().'index.php?option=com_invoicing&view=message&layout=cancel';
		
		$post = array(
				'vads_amount' => $data->gross_amount * 100,
				'vads_contrib' => 'invoicing',
				'vads_currency' => $this->config->devise,
				'vads_language' => $vads_language,
				'vads_order_id' => $data->invoicing_invoice_id,
		
				'vads_cust_id' => $user->id,
				'vads_cust_email' => $user->email,
				'vads_cust_name' => $user->name,
				
				'vads_platform_url' => 'https://paiement.systempay.fr/vads-payment/',
				'vads_site_id' => $this->config->site,
				'vads_key_test' => $this->config->test_key,
				'vads_key_prod' => $this->config->prod_key,
				'vads_ctx_mode' => $this->config->mode,
				'vads_capture_delay' => '',
				'vads_payment_cards'  => '',
				'vads_validation_mode' => '',
		
				'vads_return_mode' => 'NONE',
				'vads_redirect_enabled' => 1,
				'vads_redirect_success_timeout' => '5',
				'vads_redirect_success_message' => JText::_('VADS_REDIRECT_SUCCESS_MESSAGE'),
				'vads_redirect_error_timeout' => '5',
				'vads_redirect_error_message' => JText::_('VADS_REDIRECT_ERROR_MESSAGE'),
		
				'vads_url_return' => $url_success,
				'vads_url_success' => $url_success,
			    'vads_url_cancel' => $url_cancel
		);
		
		include(dirname(__FILE__)."/systempay/redirect.php");

	}
	
	public function onInvoicingPaymentNotification($paymentmethod, $data) 
	{	
		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
				
		InvoicingHelperLog::log("Process SystemPay");
		InvoicingHelperLog::log($_SERVER['QUERY_STRING']);
		
		$db = JFactory::getDBO();
		
		$this->config = new stdClass();
		$this->config->site = $this->params->get('site','12345678');
		$this->config->test_key = $this->params->get('test_key','1111111111111111');
		$this->config->prod_key = $this->params->get('prod_key','2222222222222222');
		$this->config->devise = $this->params->get('devise',978);
		$this->config->mode = $this->params->get('mode','TEST');
		
		$vads = new VadsApi();
		$vad_api_resp = $vads->getResponse(
									$_REQUEST, 
									$this->config->mode,
									$this->config->test_key,
									$this->config->prod_key
								   );
				
		$from_server = isset($_REQUEST['vads_hash']);

		$order_id = $vad_api_resp->get('order_id');
		
		$vads_message = $vad_api_resp->message;
		if(!empty($vad_api_resp->extraMessage)) {
			$vads_message .= '. '.$vad_api_resp->extraMessage;
		}
		if(!empty($vad_api_resp->authMessage)) {
			$vads_message .= '. '.$vad_api_resp->authMessage;
		}
		if(!empty($vad_api_resp->warrantyMessage)) {
			$vads_message .= '. '.$vad_api_resp->warrantyMessage;
		}
		
		if ($vads_message != "") {
			InvoicingHelperLog::log($vads_message);
		}	
		
		$isNetAmount = true;
		$currency = null;
		if ($this->checkValidity($order_id,$vad_api_resp->getFloatAmount(),$isNetAmount,$currency) == true) {
			$this->validPayment($order_id,$paymentmethod);
			if($from_server) {
				die($vad_api_resp->getOutputForGateway('payment_ok'));
			}
		} else {
			InvoicingHelperLog::log("payment_ko");
			$isValid = false;
			if($from_server){
				die($vad_api_resp->getOutputForGateway('payment_ko'));
			}
		}
	}
}


